using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Grouping;

namespace GGC_Forum_ResizeToFit
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControl1;
		private System.Windows.Forms.Button button1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			GridEngineFactory.Factory = new GroupingEngineFactory();

			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.button1 = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridGroupingControl1
			// 
			this.gridGroupingControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
			this.gridGroupingControl1.Location = new System.Drawing.Point(32, 32);
			this.gridGroupingControl1.Name = "gridGroupingControl1";
			this.gridGroupingControl1.Size = new System.Drawing.Size(432, 560);
			this.gridGroupingControl1.TabIndex = 0;
			this.gridGroupingControl1.Text = "gridGroupingControl1";
			this.gridGroupingControl1.VersionInfo = "4.101.0.4";
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(176, 0);
			this.button1.Name = "button1";
			this.button1.TabIndex = 1;
			this.button1.Text = "button1";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(496, 614);
			this.Controls.Add(this.button1);
			this.Controls.Add(this.gridGroupingControl1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private int nRows;
		DataTable dt;
		private void Form1_Load(object sender, System.EventArgs e)
		{
			#region Get the DataSource
			dt = new DataTable("MyTable");

			int nCols = 5;
			nRows = 8;
			Random r = new Random(123345345);

			for(int i = 0; i < nCols; i++)
				dt.Columns.Add(new DataColumn(string.Format("Col{0}", i)));

			for(int i = 0; i < nRows; ++i)
			{
				DataRow dr = dt.NewRow();
				for(int j = 0; j < nCols; j++)
					dr[j] = r.Next(1000000000).ToString();
				dt.Rows.Add(dr);
			}
			#endregion

			dt.Rows[nRows - 3]["Col1"] = "1231 231 2312 3213 123 12312 31231 2312 3123";
			this.gridGroupingControl1.DataSource = dt;

			this.gridGroupingControl1.TableDescriptor.Columns["Col1"].Width = 50;

			int colIndex = this.gridGroupingControl1.TableDescriptor.FieldToColIndex(this.gridGroupingControl1.TableDescriptor.Columns.IndexOf("Col1"));
			this.gridGroupingControl1.TableControl.Model.RowHeights.ResizeToFit(GridRangeInfo.Col(colIndex));

			this.gridGroupingControl1.TableControlCurrentCellValidating += new GridTableControlCancelEventHandler(gridGroupingControl1_TableControlCurrentCellValidating);
			this.gridGroupingControl1.TableControlCurrentCellAcceptedChanges += new GridTableControlCancelEventHandler(gridGroupingControl1_TableControlCurrentCellAcceptedChanges);
		
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			dt.Rows[3]["Col2"] = "1231 231 2312 3213 123 12312 31231 2312 3123";
			int colIndex = this.gridGroupingControl1.TableDescriptor.FieldToColIndex(this.gridGroupingControl1.TableDescriptor.Columns.IndexOf("Col2"));
			//this.gridGroupingControl1.TableControl.Model.RowHeights.ResizeToFit(GridRangeInfo.Col(colIndex));
			this.gridGroupingControl1.TableControl.Model.RowHeights.ResizeToFit(GridRangeInfo.Table());
		
			
		}

		private void gridGroupingControl1_TableControlCurrentCellValidating(object sender, GridTableControlCancelEventArgs e)
		{
			GridCurrentCell cc = e.TableControl.CurrentCell;
			e.TableControl.GetTableViewStyleInfo(cc.RowIndex, cc.ColIndex);

		}

		private void gridGroupingControl1_TableControlCurrentCellAcceptedChanges(object sender, GridTableControlCancelEventArgs e)
		{
			GridCurrentCell cc = e.TableControl.CurrentCell;
			e.TableControl.Model.RowHeights.ResizeToFit(cc.RangeInfo);
		}
	}
}
